#ifndef __Nixie_Driver_H__
#define __Nixie_Driver_H__

#include "pico/stdlib.h"

#define NIXIE_TUBE 8    // num of nixie tube
// 1 cycle length is 8 * 125 = 1000.
// 1 tube duty is 100.
// Then 1 tube has 10% duty.
#define DUTY_TUBE 125  // num of alarm per tube
#define DUTY_MAX 100   // max duty
#define DUTY_NORMAL 50 // normal duty
#define DUTY_DARK 25   // duty of dark ambient
#define NIXIE_RD_PIN 8 // R Dot PIN PWM4A
#define NIXIE_LD_PIN 9 // L Dot PIN PWM4B
#define NIXIE_DOT_PWM_WRAP 256 // 8bit
#define NIXIE_DOT_PWM_FREQ 1000 // 1kHz
#define NIXIE_DOT_PWM_CLKDIV (float)(125000000 / ((LED_PWM_WRAP) * (LED_PWM_FREQ))) // 125000000 / (256 * 1000) = 4.8828125
#define NIXIE_DOT_PWM_MAX NIXIE_DOT_PWM_WRAP
#define XFADE_MIN 0
#define XFADE_MAX 100
#define XFADE_NORMAL 75

// SPI Defines
#define SPI_PORT spi1
#define PIN_MISO 12
#define PIN_CS 13
#define PIN_SCK 10
#define PIN_MOSI 11

void SPI_init(struct repeating_timer *timer);
void nixie_dot_init(void);
bool alarm_nixie_driver_callback(struct repeating_timer *t);
void nixie_dot_pwm_init(void);

#endif