#ifndef __EXTERN_H__
#define __EXTERN_H__

#include "hardware/flash.h"
#include "command.h"
#include "common.h"
#include "DS3231.h"
#include "Nixie_Driver.h"
#include "BME280.h"

// store RTC data. declared at DS3231.h
extern struct DS3231 ds3231;
// store following number SPI map for digits
extern uint8_t digit_num[8][2];
extern const uint8_t tube_num[8];
extern const uint8_t num_order[11][2];
// GPS data
extern bool gprmc_flag;
extern uint8_t gps_time[6];
extern uint8_t gps_date[6];
// W25Q16JV the last block(Block31) sector 0 address = 0x1F0000
extern const uint32_t flash_target_offset;
// Block30 sector 0 address = 0x1E0000
extern const uint32_t flash_calibration_data_offset;
// XIP_BASE(0x10000000) is defined at flash.h
// readable by XIP flash_setting_contents[0], flash_setting_contents[1]...
extern const uint8_t *flash_setting_contents;
extern const uint8_t *flash_calibration_data_contents;
// store QSPI flash config data. declared at common.h
extern struct SETTING setting;
// store QSPI flash calibration data. declared at common.h
extern struct CALIBRATION calib;
// data for write flash
//extern uint8_t write_data[FLASH_PAGE_SIZE];
// mode
extern int mode;
extern int dot_mode;
extern int led_mode;
// shuffle
extern bool shuffle;
extern int X_num[NIXIE_TUBE];
extern bool X_pos[NIXIE_TUBE];
// xfade
extern int xfade_count;
// avoid cathode poisoning
extern bool anti_poisoning;
extern int anti_posoning_count;
// BME280
extern struct BME280_parameter BME280_param;
extern int32_t temparature, pressure, humidity;
#endif